'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var react = require('react');

function _iterableToArrayLimit(arr, i) {
  var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"];
  if (null != _i) {
    var _s,
      _e,
      _x,
      _r,
      _arr = [],
      _n = !0,
      _d = !1;
    try {
      if (_x = (_i = _i.call(arr)).next, 0 === i) {
        if (Object(_i) !== _i) return;
        _n = !1;
      } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0);
    } catch (err) {
      _d = !0, _e = err;
    } finally {
      try {
        if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return;
      } finally {
        if (_d) throw _e;
      }
    }
    return _arr;
  }
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var useAxiosLoader = function useAxiosLoader() {
  var ignoredUrls = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var _useState = react.useState(0),
    _useState2 = _slicedToArray(_useState, 2),
    counter = _useState2[0],
    setCounter = _useState2[1];
  var inc = react.useCallback(function () {
    return setCounter(function (counter) {
      return counter + 1;
    });
  }, [setCounter]);
  var dec = react.useCallback(function () {
    return setCounter(function (counter) {
      return counter - 1;
    });
  }, [setCounter]);
  var urlIsIgnored = function urlIsIgnored(url) {
    return ignoredUrls.some(function (ignoredUrl) {
      return ignoredUrl.test(url);
    });
  };
  var interceptors = react.useMemo(function () {
    return {
      request: function request(config) {
        return !urlIsIgnored(config.url) && inc(), config;
      },
      response: function response(_response) {
        return counter >= 0 && dec(), _response;
      },
      // Decrement ONLY if counter has been incremented (avoid minus values)
      error: function error(_error) {
        return counter >= 0 && dec(), Promise.reject(_error);
      }
    };
  }, [inc, dec]); // create the interceptors

  react.useEffect(function () {
    // add request interceptors
    var reqInterceptor = axios.interceptors.request.use(interceptors.request, interceptors.error);
    // add response interceptors
    var resInterceptor = axios.interceptors.response.use(interceptors.response, interceptors.error);
    return function () {
      // remove all intercepts when done
      axios.interceptors.request.eject(reqInterceptor);
      axios.interceptors.response.eject(resInterceptor);
    };
  }, [interceptors]);
  counter < 0 && setCounter(0);
  return [counter > 0];
};

exports.useAxiosLoader = useAxiosLoader;
//# sourceMappingURL=index.js.map
